/*
  @copyright Steve Keen 2019
  @author Russell Standish
  This file is part of Minsky.

  Minsky is free software: you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Minsky is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Minsky.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MINSKYRS_H
#define MINSKYRS_H
#include "minsky.h"
#include "minsky.rcd"
#include "assetClass.h"
#include "assetClass.rcd"
#include "bookmark.rcd"
#include "canvas.rcd"
#include "cairoSurfaceImage.rcd"
#include "cairoSurfaceImage.xcd"
#include "callableFunction.rcd"
#include "callableFunction.xcd"
#include "CSVParser.rcd"
#include "CSVDialog.rcd"
#include "dataSpecSchema.rcd"
#include "dimension.rcd"
#include "evalGodley.rcd"
#include "eventInterface.rcd"
#include "eventInterface.xcd"
#include "fontDisplay.rcd"
#include "godleyIcon.rcd"
#include "godleyTable.rcd"
#include "godleyTableWindow.h"
#include "godleyTableWindow.rcd"
#include "godleyTableWindow.xcd"
#include "godleyTab.rcd"
#include "godleyTab.xcd"
#include "grid.h"
#include "grid.rcd"
#include "grid.xcd"
#include "group.rcd"
#include "hypercube.h"
#include "hypercube.rcd"
#include "hypercube.xcd"
#include "item.rcd"
#include "itemTab.rcd"
#include "itemTab.xcd"
#include "index.rcd"
#include "index.xcd"
#include "noteBase.rcd"
#include "operationType.rcd"
#include "pango.rcd"
#include "pango.xcd"
#include "panopticon.rcd"
#include "parameterTab.rcd"
#include "parameterTab.xcd"
#include "plot.rcd"
#include "plot.xcd"
#include "plotTab.rcd"
#include "plotTab.xcd"
#include "plotWidget.rcd"
#include "polyRESTProcess.h"
#include "polyRESTProcessBase.rcd"
#include "polyRESTProcessBase.xcd"
#include "port.rcd"
#include "renderNativeWindow.rcd"
#include "renderNativeWindow.xcd"
#include "rungeKutta.rcd"
#include "rungeKutta.xcd"
#include "selection.rcd"
#include "lasso.rcd"
#include <signature.h>
#include "signature.rcd"
#include "signature.xcd"
#include "simulation.h"
#include "simulation.rcd"
#include "slider.rcd"
#include "stringKeyMap.rcd"
#include "SVGItem.rcd"
#include "tensorInterface.rcd"
#include "tensorInterface.xcd"
#include "tensorVal.h"
#include "tensorVal.rcd"
#include "tensorVal.xcd"
#include "variable.rcd"
#include "variableInstanceList.h"
#include "variableInstanceList.rcd"
#include "variableInstanceList.xcd"
#include "variableTab.rcd"
#include "variableTab.xcd"
#include "variableValue.rcd"
#include "variableValues.rcd"
#include "variableValues.xcd"
#include "variableType.rcd"
#include "variableValueRS.h"
#include "units.rcd"
#include "xvector.h"
#include "xvector.rcd"
#include "wire.rcd"

#include "nobble.h"


#endif
